#include "delays.i"

DDRB		=	0x04
PORTB		=	0x05	; todo remove
DDRC		=	0x07
PORTC		=	0x08
PIND		=	0x09	; todo remove
DDRD		=	0x0a
PORTD		=	0x0b
TIFR0		=	0x15
TIFR1		=	0x16	; todo remove
TIFR2		=	0x17	; todo remove
GPIOR0		=	0x1e
EECR		=	0x1f
EEDR		=	0x20
EEARL		=	0x21
EEARH		=	0x22
TCNT0		=	0x26
GPIOR1		=	0x2a
GPIOR2		=	0x2b
SPCR		=	0x2c	; todo remove
SPSR		=	0x2d	; todo remove
SPDR		=	0x2e	; todo remove
SPL		=	0x3d
SPH		=	0x3e
SREG		=	0x3f
ADMUX		=	0x7c	; todo remove
TCCR1A		=	0x80
TCNT1L		=	0x84
TCNT1H		=	0x85
OCR1BL		=	0x8a
OCR1BH		=	0x8b
TCNT2		=	0xb2
OCR2A		=	0xb3
OCR2B		=	0xb4
UBRR0L		=	0xc4	; todo remove
UBRR0H		=	0xc5	; todo remove
UDR0		=	0xc6	; todo remove

GFLAG_VBLANK		=	0
GFLAG_SONGEND		=	1
GFLAG_INIT_GREETS	=	2
GFLAG_DBLBUF		=	7

gfxptr		=	0x100
songptr		=	0x102

c_iptr		=	0		; u8		cmd 0	lookup
c_pw		=	1		; u8		cmd 1   shift4
c_ivol		=	2		; u8		cmd 2   shift2
c_noise		=	3		; u8		cmd 3   direct
c_itime		=	4		; u8		cmd 4   direct
c_vdepth	=	5		; u8		cmd 5   direct
c_vrate		=	6		; u8		cmd 6   direct
c_note		=	7		; u16 (8.8)	cmd 8/9 diff
c_glide		=	9		; s8		cmd a/b diff
c_fade		=	10		; s8		cmd c/d diff
c_pwd		=	11		; s8		cmd e/f diff
c_vpos		=	12		; u8
c_transp	=	13		; s8
c_tptr		=	14		; ptr
c_tbits		=	16		; u8
c_lasti		=	17		; u8
c_freq		=	18		; u16
c_vol		=	20		; u8

c_sz		=	21

	; Wipe parameters are stored near the copperlist

cl_pic		=	8
cl_xoffs	=	9
cl_colour	=	10
cl_flash	=	11
