#include "demo.i"

		.global	main
		.global unpack
		.global wait
		.global loadcopper

main:
		eor	r3, r3

		ldi	r30, lo8(pokelist)
		ldi	r31, hi8(pokelist)
		ldi	r27, 0
1:
		lpm	r26, Z+
		lpm	r16, Z+
		st	X, r16
		cpi	r30, lo8(pokelist_end)
		brne	1b

		ldi	r26, 0x00
		ldi	r27, 0x01
2:
		lpm	r16, Z+
		st	X+, r16
		cpi	r26, 4
		brne	2b
3:
		st	X+, r3
		cpi	r27, 0x05
		brne	3b

		mov	r12, r2
		eor	r13, r13

		; Prepare for quilt
		mov	r14, r2
		eor	r15, r15
		;sts	scratch+0, r3
		ldi	r16, 7
		sts	scratch+1, r16

		rcall	blank
		sei

runstory:
		ldi	r28, lo8(story)
		ldi	r29, hi8(story)
		ldi	r25, 0
1:
		sbic	GPIOR0, GFLAG_SONGEND
		rjmp	1b

		rcall	ophuffman

		mov	r30, r16
		andi	r30, 0x1f
		subi	r30, 0x80

		andi	r16, 0x60
		brne	2f

		; Call

		ldi	r31, hi8(pm(jumptable))
		icall
		rjmp	1b
2:
		sbrc	r16, 5
		sts	mainvector, r30
		sbrc	r16, 6
		sts	vblvector, r30
		rjmp	1b

unpack:
		push	r25
		push	r28
		push	r29

		lds	r28, gfxptr
		lds	r29, gfxptr+1
		lds	r25, gfxbits
		rcall	unpackpic
		sts	gfxptr, r28
		sts	gfxptr+1, r29
		sts	gfxbits, r25
popret:
		pop	r29
		pop	r28
		pop	r25
		ret

wait:
		rcall	ophuffman

		push	r25
		push	r28
		push	r29

		lds	r18, storywait
		lds	r19, storywait+1
		lsl	r16
		add	r18, r16
		adc	r19, r3
		add	r18, r16
		adc	r19, r3
		sts	storywait, r18
		sts	storywait+1, r19
1:
		rcall	waitvbl

		ldi	r28, lo8(scratch)
		ldi	r29, hi8(scratch)

		lds	r30, mainvector
		ldi	r31, hi8(pm(jumptable))
		icall

		in	r20, GPIOR1
		in	r21, GPIOR2
		lds	r16, storywait
		lds	r17, storywait+1
		cp	r20, r16
		cpc	r21, r17
		brlo	1b

		rjmp	popret

loadcopper:
		rcall	blankfield		; prevent race condition with video interrupt

		ldi	r16, 0xaa - 0x33
		sts	coppertime+cl_flash, r16

		rcall	ophuffman
		add	r19, r16		; r19 points to field

		rcall	ophuffman
		mov	r18, r16
		ldi	r26, lo8(coppertime)
		ldi	r27, hi8(coppertime)
1:
		rcall	ophuffman
		lsl	r16
		st	X+, r16
		subi	r18, 1
		brne	1b

		sts	copperfield, r19
		ret
